package main

import (
	"strings"
	"time"

	b64 "encoding/base64"

	twitterscraper "github.com/imperatrona/twitter-scraper"
)

// task

// func sync() error {

// 	idxs, err := GetIndexList()

// 	if err != nil {
// 		return err
// 	}

// 	done := make(chan interface{})

// 	defer close(done)

// 	backListStream, err := FollowersToBackList(done, idxs)
// 	if err != nil {
// 		return err
// 	}

// 	usersStream := BackListToQueue(done, backListStream)

// 	if err := InsertOrUpdateUsers(done, usersStream); err != nil {
// 		return err
// 	}

// 	select {}

// }

// func sync() error {

// 	idxs, err := GetTasksFollowIdx()

// 	//idxs, err := GetIndexList()

// 	if err != nil {
// 		return err
// 	}

// 	done := make(chan interface{})

// 	defer close(done)

// 	backListStream, err := FollowersToBackList(done, idxs)
// 	if err != nil {
// 		return err
// 	}

// 	_ = backListStream
// 	return nil
// }

func tasks(done <-chan interface{}, inStream <-chan TaskParam) (<-chan TaskParam, <-chan TaskParam) {

	outResource := make(chan TaskParam)
	outDb := make(chan TaskParam)

	go func() {

	}()

	return outResource, outDb

}

type TwitterUserPasswd struct {
	User   string
	PassWd string
}

var twitterUsers []TwitterUserPasswd

func Resource() ([]*twitterscraper.Scraper, error) {

	users := make([]struct {
		User   string
		PassWd string
	}, 0)

	users = append(users, struct {
		User   string
		PassWd string
	}{
		User:   "Wade_Leeeee",
		PassWd: "923881393time",
	})

	res := make([]*twitterscraper.Scraper, 0, len(users))

	for _, v := range users {

		scraper, err := InitScraper(v.User, v.PassWd)

		if err != nil {
			return nil, err
		}

		res = append(res, scraper)

	}

	return res, nil
}

func InitScraper(user, password string) (*twitterscraper.Scraper, error) {

	scraper3 := twitterscraper.New()

	//err := scraper3.Login("Wade_Leeeee", "923881393time")

	if err := scraper3.Login(user, password); err != nil {
		return nil, err
	}

	// Deserialize from JSON
	// var cookies []*http.Cookie
	// f, _ := os.Open("cookies.json")
	// json.NewDecoder(f).Decode(&cookies)

	// scraper3.SetCookies(cookies)
	// if !scraper3.IsLoggedIn() {
	// 	panic("Invalid cookies")
	// }

	return scraper3, nil

}

type TaskParam struct {
	Follow Follow
}

type Retweet struct {
	Enable bool
	User   string
	Next   string
	Res    chan interface{}
}

type Follow struct {
	Enable bool
	User   string
	Next   string
	Res    chan Users
}

func ImplementTask(done <-chan interface{}, scraper3 *twitterscraper.Scraper, tickerD time.Duration, inStream <-chan TaskParam) {

	go func() {

		ticker := time.NewTicker(tickerD)

		for {

			select {

			case <-done:
				return

			case <-ticker.C:

				select {
				case <-done:
					return
				case req := <-inStream:
					if req.Follow.Enable {

						followers, err := FetchFollowers(scraper3, req.Follow.User, req.Follow.Next)
						followers.Error = err

						select {
						case <-done:
							return
						case req.Follow.Res <- followers:
						}
					}
				}
			}
		}
	}()
}

func FetchFollowers(scraper *twitterscraper.Scraper, user, next string) (Users, error) {

	users, newNext, err := scraper.FetchFollowers(user, 20, next)

	if err != nil {
		return Users{}, err
	}

	usersWithUserNumber := make([]Profile, 0, len(users))

	for _, v := range users {
		sDec, _ := b64.StdEncoding.DecodeString(v.UserID)
		userId, _ := strings.CutPrefix(string(sDec), "User:")
		item := Profile{
			UserIdAsNumber: userId,
			Profile:        v,
		}
		usersWithUserNumber = append(usersWithUserNumber, item)
	}

	res := Users{
		Profiles: usersWithUserNumber,
		Current:  next,
		Next:     newNext,
	}

	return res, nil
}
